using System;
using System.Collections;
using System.Collections.Generic;
using MacGruber;
using UnityEngine;
using Request = MeshVR.AssetLoader.AssetBundleFromFileRequest;

namespace CheesyFX
{
    public class SlapMe : MVRScript
    {
        public static SlapMe singleton;
        public static Atom atom;
        public static AudioSource headAudioSource;

        public static JSONStorableBool slapVocalsEnabled = new JSONStorableBool("Slap Vocal Reaction Enabled", false);
        public static JSONStorableBool slapMoanEnabled = new JSONStorableBool("Slap Moans Enabled", true);
        public static JSONStorableBool sexSlapMoanEnabled = new JSONStorableBool("Sex Slap Moans Enabled", true);
        public static JSONStorableBool isSlappingOthers = new JSONStorableBool("Slap Others Enabled", true);
        public static JSONStorableFloat slapVolume = new JSONStorableFloat("Slap Volume", 1f, 0f, 10f, false);
        public static JSONStorableFloat sexSlapVolume = new JSONStorableFloat("Sex Slap Volume", 1f, 0f, 10f, false);
        public static JSONStorableFloat sexSlapThreshold = new JSONStorableFloat("Sex Slap Threshold", .05f, 0f, .2f, false);
        public static JSONStorableFloat slapThreshold = new JSONStorableFloat("Slap Threshold", 1f, 0f, 2f, false);
        public JSONStorableFloat maxMorphVal = CheesyUtils.SetupJSONFloat("Max Morph Value", .5f, 0f, 1f);
        public JSONStorableFloat painTreshold = CheesyUtils.SetupJSONFloat("Pain Thresold", .5f, 0f, 1f);

        // public static JSONStorableStringChooser vammoanSlapVoice =
	       //  new JSONStorableStringChooser("vammoanSlapVoice", null, "Isabella", "VAMMoan Voice");

        private static float sexSlapIntensity;
        // private static float slapIntensity;
        AudioSource slapAS;
        private static AudioSource sexSlapAS;
        private static IEnumerator sexSlap;
        
        public static ClipLibrary slapLibrary;
        public static ClipLibrary sexSlapLibrary;
        public static ClipLibrary buttSlapLibrary;
        public static ClipLibrary moanLibrary;
        
        public static ExpressionManager expressionManager;

        private bool vammoanPackageInstalled;
        public static JSONStorableStringChooser voice = new JSONStorableStringChooser("vammoanSlapVoice",
	        new List<string>{"Abby", "Claire", "Ella", "Emma", "Grace", "Isabella", "Lana", "Lia", "Lillian", "Lise", "Seth", "Skye", "Yumi"},
	        "Isabella", "VAMMoan Voice");
        public static JSONStorableStringChooser vamMoanVoice;
        public static string packageUid;
        
        public override void Init()
        {
            singleton = this;
            atom = containingAtom;
            packageUid = Utils.GetPackagePath(this);
            headAudioSource = atom.GetStorableByID("HeadAudioSource").GetComponent<AudioSource>();
            expressionManager = gameObject.AddComponent<ExpressionManager>();
            BodyRegionMapping.Init(atom);

            slapLibrary = new ClipLibrary("slaps");
            sexSlapLibrary = new ClipLibrary("sexslaps");
            buttSlapLibrary = new ClipLibrary("buttslaps");
            moanLibrary = new ClipLibrary("moans");
            var slapsPath = packageUid + "Custom/Scripts/CheesyFX/BodyLanguage/audiobundles/slaps.audiobundle";
            AudioImporter.GetClipsFromAssetBundle(new List<ClipLibrary>{slapLibrary, sexSlapLibrary, buttSlapLibrary},
	            slapsPath);
            string vamMoanPackageUid = CheesyUtils.GetLatestPackageUid("hazmhox.vammoan");
            if (vamMoanPackageUid != null)
            {
	            vammoanPackageInstalled = true;
	            string bundlePath = vamMoanPackageUid + ":/Custom/Scripts/VAMMoan/audio/voices.voicebundle";
	            AudioImporter.GetClipsFromAssetBundle(moanLibrary, bundlePath);
            }
            else
            {
	            vammoanPackageInstalled = false;
	            slapMoanEnabled.val = false;
	            sexSlapMoanEnabled.val = false;
            }
            slapMoanEnabled.setCallbackFunction += val =>
            {
	            if (val && !vammoanPackageInstalled)
	            {
		            SuperController.LogError("SlapMe: Download VAMMoan to enable moan reactions.");
		            slapMoanEnabled.valNoCallback = false;
	            }
            };
            sexSlapMoanEnabled.setCallbackFunction += val =>
            {
	            if (val && !vammoanPackageInstalled)
	            {
		            SuperController.LogError("SlapMe: Download VAMMoan to enable moan reactions.");
		            sexSlapMoanEnabled.valNoCallback = false;
	            }
            };
            var vammoan = this.FindPluginPeer("VAMMoan");
            if (vammoan)
            {
	            vamMoanVoice = vammoan.GetStringChooserJSONParam("voice");
	            voice.val = vamMoanVoice.val;
	            vamMoanVoice.setCallbackFunction += val => voice.val = val;
            }
            else RetrySyncWithVamMoan().Start();
            voice.setCallbackFunction += val =>
            {
	            AudioImporter.ReadBundle("VAMMoan", moanLibrary);
	            if (vamMoanVoice != null) vamMoanVoice.val = val;
            };
            CreateUI();
        }

        private void CreateUI()
        {
	        slapVolume.CreateUI(script:this);
	        sexSlapVolume.CreateUI(script:this, rightSide:true);
	        slapMoanEnabled.CreateUI(script: this);
	        sexSlapMoanEnabled.CreateUI(script: this);
	        voice.CreateUI(script: this, rightSide:true, chooserType:1);
	        // UIManager.SetupInfoOneLine(null, "Expressions", false, false, this);
	        // var textfield = CreateTextField(new JSONStorableString("", "Expressions"));
	        // textfield.height = 50f;
	        // textfield.UItext.alignment = TextAnchor.MiddleCenter;
	        ExpressionManager.slapExpressionsEnabled.CreateUI(script:this, rightSide:false);
	        ExpressionManager.sexSlapExpressionsEnabled.CreateUI(script:this, rightSide:false);
	        expressionManager.stimulation.CreateUI(script:this);
	        ExpressionManager.joyExpressionScale.CreateUI(script:this, rightSide:true);
	        ExpressionManager.painEpressionScale.CreateUI(script:this, rightSide:true);
	        ExpressionManager.painTreshold.CreateUI(script:this, rightSide:false);
	        
        }
        
        public static void Slap(TouchZone touchZone, Collision collision)
		{
			// if (touchZone.name == "Anus") return;
			// if (!enabled || !touchZone.slapEnabled.val) return;
			ContactPoint contactPoint = collision.contacts[0];
			Vector3 velocity = collision.relativeVelocity;
			float intensity = Vector3.Dot(velocity, contactPoint.normal);
			if(intensity < .01f) return;
			touchZone.slapAudioObject.transform.position = contactPoint.point;
			AudioSource audioSource = touchZone.slapAudioSource;
			Atom collidingAtom = collision.rigidbody.GetAtom();
			string collidingRegion = collision.rigidbody.GetRegion();
			bool selfSlap = collidingAtom == atom;
			bool slappedByPerson =
				(collidingAtom.type == "Person" &&
				 (collidingRegion.Contains("Hand") || collidingRegion.Contains("Arm"))) ||
				collidingAtom.type == "Dildo" || collidingAtom.type == "Paddle" || collidingAtom.type == "Capsule";
			bool collidingAtomIsPenetrating = FillMeUp.penetratingAtoms.Values.ToList().Contains(collidingAtom);
			if (collidingAtomIsPenetrating &&
			    (collidingRegion == "Penis" || collidingRegion == "DildoPenis")) return;
			// collidingRegion.Print();
			if(
				collidingAtomIsPenetrating
				&& intensity > sexSlapThreshold.val
				&& (touchZone.name.Contains("Thigh") || touchZone.name.Contains("Glutes") || touchZone.name == "Labia" || touchZone.name == "Vagina")
				&& collidingRegion != null 
				&& (collidingRegion == "Pelvis" || collidingRegion == "Abdomen"  || collidingRegion.Contains("Thigh") || collidingRegion == "Testes" || collidingRegion == "DildoSack")
				// && !touchZone.collisionListener.stuffColliding.Any(x => x.GetBodyRegion() == collidingRegion)
			)
			{
				if (intensity < sexSlapIntensity) return;
				sexSlapIntensity = intensity;
				sexSlapAS = audioSource;
				if(sexSlap == null) sexSlap = SexSlap(touchZone).Start();
				
			}
			else{
				if(intensity < slapThreshold.val) return;
				// (collision.rigidbody.name+"->"+touchZone.name).Print();
				List<BodyRegion> touchedParents = touchZone.parents;
				if (touchedParents.Exists(x => x.name.Contains("Hand")) ||
				    touchedParents.Exists(x => x.name.Contains("ForeArm")))
				{
					if (selfSlap || !isSlappingOthers.val) return;
				}
				bool slappedByOtherPerson = !selfSlap && slappedByPerson;
				touchZone.Slap(intensity, touchZone, collision,slapVocalsEnabled.val && slappedByOtherPerson, slapMoanEnabled.val && slappedByOtherPerson);
			}
		}
        
        private static IEnumerator SexSlap(TouchZone touchZone){
	        AudioClip clip = buttSlapLibrary.GetRandomClip();
	        yield return new WaitForSeconds(.025f);
	        float volumeFactor = sexSlapIntensity*sexSlapIntensity*2f*sexSlapVolume.val;
	        sexSlapAS.pitch = Mathf.Lerp(.8f, 1.2f, sexSlapIntensity);
	        sexSlapAS.PlayOneShot(clip, volumeFactor);
	        // if(globalSlapMoanReactionEnabled.val) AudioManager.moanClips.PlayRandom(allowRepeat:true);
	        if(ExpressionManager.sexSlapExpressionsEnabled.val) expressionManager.Stimulate(touchZone, sexSlapIntensity*6f);
	        if(sexSlapMoanEnabled.val) moanLibrary.Play(SlapMe.headAudioSource);
	        sexSlapIntensity = 0f;
	        sexSlap = null;
        }

        private IEnumerator RetrySyncWithVamMoan()
        {
	        yield return new WaitForEndOfFrame();
	        for (int i = 0; i < 5; i++)
	        {
		        yield return new WaitForSeconds(2f);
		        var vammoan = this.FindPluginPeer("VAMMoan");
		        if (vammoan)
		        {
			        vamMoanVoice = vammoan.GetStringChooserJSONParam("voice");
			        voice.val = vamMoanVoice.val;
			        vamMoanVoice.setCallbackFunction += val => voice.val = val;
			        yield break;
		        }
	        }
        }

        private void OnDestroy()
        {
	        foreach(TouchZone touchZone in BodyRegionMapping.touchZones.Values.ToList()){
		        touchZone.Destroy();
	        }
            AudioImporter.UnloadBundles();
        }
    }
}