using System;
using System.Linq;
using System.Collections;
using System.Collections.Generic;
using MeshVR;
using UnityEngine;
using UnityEngine.EventSystems;
using MacGruber;

namespace CheesyFX
{
	public class TouchCollisionTrigger : MonoBehaviour
	{
		public TouchZone touchZone;
		public Rigidbody rigidbody;
		float onStayTimer = 0f;
		public HashSet<Rigidbody> stuffColliding = new HashSet<Rigidbody>();
		IEnumerator IEnumOnStayCheck;
		public JSONStorableBool isColliding;
		
		public Collision lastCollision;
		

		public void Init(TouchZone bodyRegion, Rigidbody rb){
			touchZone = bodyRegion;
			rigidbody = rb;
			// isColliding = new JSONStorableBool("isStuffed", false, isCollidingCB);
		}

		void RegisterCollision(Collision collision){
			stuffColliding.Add(collision.rigidbody);
			touchZone.touchCollisionListener.RegisterCollision(this);
		}

		public void OnCollisionEnter(Collision collision){
			if(SlapMe.singleton.enabled)
			{
				// collision.rigidbody.name.Print();
				Rigidbody other = collision.rigidbody;
				if(other.GetAtom() == SlapMe.atom)
				{
					return;
					// string otherRegion = other.GetRegion();
					// if(otherRegion != "lHand") return;
				}
				// touchZone.name.Print();
				lastCollision = collision;
				RegisterCollision(collision);
			}
		}

		public void OnCollisionExit(Collision collision){
			stuffColliding.Remove(collision.rigidbody);
			touchZone.touchCollisionListener.DeregisterCollision(collision);
		}
		
		// public void OnTriggerEnter(Collider collider){
		// 	if(UIManager.script.enabled){
		// 		if (BodyManager.viewScanEnabled.val && collider == BodyManager.viewTrigger)
		// 		{
		// 			touchZone.collisionListener.RegisterLookAt();
		// 		}
		// 	}
		// }
		
		// public void OnTriggerExit(Collider collider){
		// 	if (BodyManager.viewScanEnabled.val && collider == BodyManager.viewTrigger)
		// 	{
		// 		touchZone.collisionListener.DeregisterLookAt();
		// 	}
		// }

		// public void OnParticleCollision(GameObject other)
		// {
		// 	var cumRegion = touchZone.cumRegion;
		// 	cumRegion?.Increase(.02f);
		// }
	}
	
}